﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;

namespace NTK.Demos
{
    partial class DocumentCreator
    {
        internal static XmlElement RawXMLPerson_v1()
        {
            XmlDocument person = new XmlDocument();
            person.LoadXml("<Person xmlns='http://schemas.gama-system.com/person_v1' version='1'><Name>Janez</Name><Surname>Novak</Surname></Person>");
            return person.DocumentElement;
        }

        internal static XmlElement RawXMLPerson_v2()
        {
            const string p_v2namespace = "http://schemas.gama-system.com/person_v2";
            XmlDocument person = new XmlDocument();

            // root
            XmlElement root = person.CreateElement("p", "Person", p_v2namespace);
            person.AppendChild(root);

            // version attribute
            XmlAttribute version = person.CreateAttribute("version");
            version.InnerText = "2";
            root.Attributes.Append(version);

            // name
            XmlElement elem = person.CreateElement("p", "Name", p_v2namespace);
            elem.InnerText = "Metka";
            root.AppendChild(elem);

            // surname
            elem = person.CreateElement("p", "Surname", p_v2namespace);
            elem.InnerText = "Skubic";
            root.AppendChild(elem);

            // age
            elem = person.CreateElement("p", "Age", p_v2namespace);
            elem.InnerText = "23";
            root.AppendChild(elem);

            return person.DocumentElement;
        }
    }
}
