using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Description;
using System.Xml;

namespace NTK.Demos
{
    public class CRMService : ICRMService
    {
        Guid ICRMService.CreatePerson(XmlDocument person)
        {
            Console.WriteLine("Start: CreatePerson");
            Guid newGuid = Guid.Empty;
            int schemaVersion = PersonValidator.GetSchemaVersion(person);
            Console.WriteLine("Person Schema Version: {0}", schemaVersion);

            if (PersonValidator.IsRepresentationValid(person))
            {
                // display document validity
                Console.WriteLine("Document valid against schema version {0}.", schemaVersion);

                // display person name
                Console.WriteLine("Person: {0}", PersonValidator.GetNameSurname(person));

                // store into db
                Console.WriteLine("Person Created.");
                newGuid = Guid.NewGuid();
            }
            else
            {
                // display document validity
                Console.WriteLine("Document is INVALID against schema version {0}.", schemaVersion);
            }

            Console.WriteLine("End: CreatePerson\n");
            return newGuid;
        }

        Guid ICRMService.UpdatePerson(XmlDocument person)
        {
            throw new NotImplementedException();
        }

        void ICRMService.DeletePerson(Guid personID)
        {
            throw new NotImplementedException();
        }

        XmlDocument ICRMService.GetPerson(Guid personID)
        {
            throw new NotImplementedException();
        }
    }

    class Hoster
    {
        static void Main(string[] args)
        {
            using (ServiceHost sh = new ServiceHost(typeof(CRMService)))
            {
                sh.Open();
                Console.WriteLine("Service listening on: ");
                foreach (ServiceEndpoint se in sh.Description.Endpoints)
                {
                    Console.WriteLine(se.ListenUri.ToString());
                }
                Console.WriteLine();
                Console.ReadLine();
                sh.Close();
            }
        }
    }
}
